#include "beneftis.h"

void add_risk(risk_hash **risk,int pid,int m, float beneficio){

    risk_hash *r;

    r = (risk_hash*)malloc( sizeof(risk_hash) );
    memset(r, 0, sizeof(risk_hash));

    r->benefit.pid = pid;
    r->benefit.m = m;
    r->beneficio = beneficio;

    HASH_ADD(hh, *risk, benefit, sizeof(risk_hash), r);

}

risk_hash *delete_risk(risk_hash **risk, risk_key l) {

    risk_hash *r,z;

    memset(&z, 0, sizeof(risk_hash));

    z.benefit.pid = l.pid;
    z.benefit.m = l.m;

    for(r=*risk; r!= NULL; r=r->hh.next){
        //printf("\n\nr->pid: %d r->m:%d ",r->benefit.pid,r->benefit.m);
        //printf("\n\nz->pid: %d z->m:%d ",z.benefit.pid,z.benefit.m);
        if((r->benefit.pid == z.benefit.pid) && (r->benefit.m == z.benefit.m)){
            HASH_DEL(*risk, r);
            free(r);
            break;
        }
    }
   // printf(" count:%d\n\n",HASH_COUNT(*risk));

    return *risk;

}

void print_risk(risk_hash **risk){
    risk_hash *r;

    for(r = *risk; r != NULL; r =(risk_hash*) (r->hh.next)){

        printf("d:%d m:%d ",r->benefit.pid,r->benefit.m);
        printf("%.4f \n",r->beneficio);

    }
}

float benefit_per_pair(float Rp,int m,int dp,float rpt){

    float b = Rp*((2*T - m - dp + 1) / rpt);
    return b;
}

void calcule_benefit(risk_hash **Hight_risk1,risk_hash **Normal_risk1,projectsh **project, pwphs **pwp){

    projectsh *s,*l;
    pwphs *q;

    HASH_ITER(hh,*project,s,l){

        if( (q = find_project_to_warning_points(*pwp,s->pid)) ){

            if(strcmp(s->project.obrigatory,"M") != 0){
                /*Projeto de alto risco*/
                if(q->pwp.risk == 1){
                    for(int m = 1; m <= T; m++){

                        add_risk(Hight_risk1,s->pid,m, benefit_per_pair(s->project.Rp,m,s->project.duration,s->project.cost_total));
                    }
                }
                /*Projeto de risco normal*/
                else{
                    for(int m = 1; m <= T; m++){

                        add_risk(Normal_risk1,s->pid,m, benefit_per_pair(s->project.Rp,m,s->project.duration,s->project.cost_total));

                    }

                }
            }
        }
    }
}

int beneficio_sort(risk_hash *a, risk_hash *b) {
    return (b->beneficio - a->beneficio);
}

void sorting(risk_hash **risk) {
    HASH_SORT(*risk, beneficio_sort);
}


void copy_risk_hash(risk_hash **High_risk, risk_hash **Normal_risk,risk_hash **High_risk2,risk_hash **Normal_risk2){

    risk_hash *s,*l;


    /*Percorre toda a hash de High risk e copia para sua auxiliar High_risk1*/
    HASH_ITER(hh,*High_risk,s,l){

        add_risk(High_risk2,s->benefit.pid,s->benefit.m,s->beneficio);

    }


    /*Percorre toda a hash de High risk e copia para sua auxiliar High_risk1*/
    HASH_ITER(hh,*Normal_risk,s,l){

        add_risk(Normal_risk2,s->benefit.pid,s->benefit.m,s->beneficio);

    }

}




