#include "brkga.h"


solutionhs *generate_mutant(projectsh **projects, projectsh **mandatory_projects,warning_pointshs **wp ,solutionhs **P, resources res){

    solutionhs *s,*l;
    projectsh *q;
    int m;
    solutionhs *mutant = NULL;

    /*
    copy_solution_without_fitness(P,&mutant);

    HASH_ITER(hh, mutant, s, l){

        //A fitness est armazenada no pid -1 e projetos com ms 61 no sero modificados.
        if((s->pid != -1) && (s->m < 61)){

            q = find_project(*projects,s->pid);

            if(strcmp(q->project.obrigatory,"N") == 0){
                s->m = (rand()%60 + q->project.leadTime + 1) - 15;
                //add_population_classification(&mutant,2);
            }
        }
    }*/

    schedule_mandatory_projects_in_solution(&mutant,mandatory_projects);

    HASH_ITER(hh, *P, s, l){

        if((s->pid != -1) && (s->m < 61)){

            q = find_project(*projects,s->pid);

            /*O projeto no  obrigatrio*/
            if(strcmp(q->project.obrigatory,"N") == 0){
                m = (rand()%60 + q->project.leadTime+1)-15;
                add_solution(&mutant,s->pid,m);
                /*Quando adiciona o novo projeto e a soluo for invlida, ela  deletada da soluo.*/
                if(! (is_solution_valid(&mutant,mandatory_projects,projects,res) )){
                    //printf("\n\ns->pid:%d m:%d s->leadtime:%d",s->pid,m,s->project.leadTime);
                    delete_from_solution(&mutant,s->pid);
                }
            }
        }
    }

    return mutant;

}

solutionhs *crossover(solutionhs **fatherA, solutionhs **fatherB, projectsh **projects, projectsh **mandatory_projects, resources res){


    solutionhs *q;
    solutionhs *child = NULL;
    int coin;

    /*printf("\nFatherA:\n");
    print_solutions(fatherA);
    printf("\nFatherB:\n");
    print_solutions(fatherB);*/

    for(int i = 1; i <= HASH_COUNT(*fatherA) - 1; i++){

        coin = rand()%10 + 1;

        /*60% no-elite*/
        if(coin < 7){

            //printf("\n\nEscolheu A");
            q = find_solution(*fatherA,i);

        /*40% no-elite*/
        }else{
            //printf("\n\nEscolheu B");
            q = find_solution(*fatherB,i);

        }
        //printf(" %d",q->pid);
        add_solution(&child,q->pid,q->m);

    }

    return child;

}



solutionhs *BRKGA_(projectsh **projects,projectsh **mandatory_projects,pwphs **pwp,warning_pointshs **wp,resources *res){


    float fitness_value = 0;
    float best_fitness = FLT_MAX;
    solutionhs *best_solution = NULL;
    solutionhs *populations[POPULATION_SIZE];
    solutionhs *next_population[POPULATION_SIZE];
    solutionhs *q;
    int count_elite;
    int count_no_elite;

    int countTimes = 0;

    int i,j,l;
    i = 0;
    j = 0;
    l = 0;

    srand(time(NULL));
    printf("\n\nGeracao da populacao");
    /*Inicializando os vetores de solues.*/
    for(int o = 0; o < POPULATION_SIZE; o++){
        populations[o] = NULL;
        next_population[o] = NULL;
    }

    while(i < CRITERIO_DE_PARADA){

        /*

        GERAO DA POPULAO INICIAL.

        */
        while(j < POPULATION_SIZE){

            /*gera uma soluo inicial.*/

            generate_solution(projects,mandatory_projects,wp,&populations[j],*res);

            /*Se no atender a restrio de pontos intolerveis.*/
            if( !(intolerable_points(wp,projects,&populations[j])) ){
                //print_solutions(&populations[j]);
                countTimes++;
                if(countTimes == 50){
                    printf("\n\nEntrada invalida");
                    exit(1);
                }

                populations[j] = NULL;
                //system("pause");

            }else{
                fitness_value = fitness(&populations[j],projects,wp);
                add_fitness_to_solution(&populations[j],fitness_value);
                schedule_projects_that_are_not_in_solution(projects,&populations[j]);
                countTimes = 0;
                j++;
            }


        /*end while(j < C)*/
        }
        //Resetando o valor do limite de vezes
        /*for(int i = 0; i < POPULATION_SIZE; i++){
            printf("\n\nSolucao: %d\n", i+1);
            print_solutions(&populations[i]);
        }*/
        /*Ordenando decrescente por fitness*/
        insertion_sort(populations,POPULATION_SIZE);

        while(l < CRITERIO_DE_REINICIALIZACAO){

            /*

            CLASSIFICANDO EM ELITE E NO ELITE.

            */


            for(int index = 0; index < POPULATION_SIZE; index++){
                if(index < floor(POPULATION_SIZE * ELITE_PERCENTAGE)){
                    /*classifica a populao em elite*/
                    add_population_classification(&populations[index],0);
                    //printf("\n\nElite");
                }else{
                    /*classifca a populao em no-elite*/
                    add_population_classification(&populations[index],1);
                    //printf("\n\nnao-elite");
                }
                //printf("\nIndividuos %d",index+1);
                //print_solutions(&populations[index]);
            }



            /*

            COPIANDO ELITES.

            */


            /*Copiando os indivduos elite para a nova populao.*/
            int index = 0;
            while(index < floor(POPULATION_SIZE * ELITE_PERCENTAGE)){
                next_population[index] = populations[index];
                index++;
            }


            count_elite = index; /*Recebe a quantidade de elite.*/


            /*

           MUTANTES

            */

            int limite = index + floor(POPULATION_SIZE * MUTANT_PERCENTAGE);
            while(index < limite){

                int m = rand()%POPULATION_SIZE;
              //  printf("\n\nEscolheu a solucao %d\n",m);

                next_population[index] = generate_mutant(projects,mandatory_projects,wp,&populations[m],*res);

                if( !(intolerable_points(wp,projects,&next_population[index])) ){
                    next_population[index] = NULL;
                    countTimes++;
                    if(countTimes == 50){
                        printf("\n\nErro na geracao de mutantes");
                        exit(1);
                      }
                }else{

                    //printf("\n\nMutante\n");
                    //print_solutions(&populations[m]);

                    /*Para alterar o valor fitness da soluo.*/
                    schedule_projects_that_are_not_in_solution(projects,&next_population[index]);

                    fitness_value = fitness(&next_population[index], projects,wp);
                    add_fitness_to_solution(&next_population[index],fitness_value);
                    add_population_classification(&next_population[index],2);

                    index++;
                    countTimes = 0;
                }
            }

            count_no_elite = POPULATION_SIZE - count_elite;/*Recebe a quantidade de no-elite.*/


            /*

            CROSSOVER

            */


            while(index < POPULATION_SIZE){
                /*Random da posio dos elementos elite no vetor population.*/
                int elite_father = rand()%count_elite;
                /*Random da posio dos elementos no-elite no vetor population.*/
                int non_elite_father = rand()%count_no_elite + count_elite;

               /*printf("\nelite_father:%d non_elite_father:%d\n",elite_father,non_elite_father);
                printf("\nFatherA");
                print_solutions(&next_population[elite_father]);
                printf("\n\n\nFatherB");
                print_solutions(&next_population[non_elite_father]);*/

                //Gerar mutante
                //printf("\nelite:%d non_elite:%d",elite_father,non_elite_father);
                next_population[index] = crossover(&populations[elite_father],&populations[non_elite_father], projects, mandatory_projects, *res);

                if( !(is_solution_valid(&next_population[index],mandatory_projects,projects,*res) ) || (!(intolerable_points(wp,projects,&next_population[index]))) ){

                    //print_solutions(&next_population[index]);
                    next_population[index] = NULL;
                    countTimes++;
                    if(countTimes == 50){
                        //printf("%d ",countTimes);
                        printf("\n\nGeracao de crossover invalida");
                        exit(1);
                    }
                }else{
                    //schedule_projects_that_are_not_in_solution(projects,&next_population[index]);
                    fitness_value = fitness(&next_population[index],projects,wp);
                    add_fitness_to_solution(&next_population[index],fitness_value);

                    /*printf("\n\nSolucao pai A");
                    print_solutions(&populations[elite_father]);

                    printf("\n\nSolucao pai B");
                    print_solutions(&populations[non_elite_father]);

                    printf("\n\nSolucao filho %d",index);
                    print_solutions(&next_population[index]);*/
                    countTimes=0;
                    index++;
                }
            }

            /*Ordenando decrescente*/
            insertion_sort(next_population,POPULATION_SIZE);

            /*

            ATUALIZANDO A NOVA POPULAO

            */

            for(index = 0; index < POPULATION_SIZE; index++){

                populations[index] = NULL;
                populations[index] = next_population[index];
                //printf("\n\nAtualizando populacao %d",index+1);
                //print_solutions(&populations[index]);

            }

            q = find_solution(next_population[0],-1);

            //printf("\n\nnext_pop->fitnes:%.2f   best_fitness:%2.f",q->fitness,best_fitness);
            if(q->fitness < best_fitness){

                best_solution = NULL;
                copy_solution(&next_population[0],&best_solution);
                best_fitness = q->fitness;

                //printf("\n\nMelhor solucao");
                //print_solutions(&best_solution);

            }

            l++;

        }
        i++;
    }
    printf("\n\nEncerrou");

    return best_solution;
}
