#ifndef CONSTRAINTS
#define CONSTRAINTS

#include <time.h>
#include "projects.h"
#include "solution.h"

/*Verifica se os projetos obrigatórios estão na solução*/
int check_projects_mandatory_scheduling(projectsh **mandatory_projects, solutionhs **P);

/*Faz soma de custos de todos os projetos de cada recurso(Capex ou Opex) por ano(1 a 5).*/
float yearlycost(solutionhs **P, projectsh **project, char classification[5],int year);

/*Verifica se o custo total dos projetos ultrupassam o rescurso disponivel*/
int check_costs_constraints(solutionhs **P, projectsh **project, resources res);

/*Verifica se o mês do projeto respeita o seu tempo de espera.*/
int lead_time(solutionhs **P, projectsh **project);

/*Para uma determina usina e mês conta quantas usinas são de manutenção e estão paradas no mês dado.*/
int count_halting_generating_units_per_month(solutionhs **P, projectsh **project,int month,char area[]);

/*Para uma determina usina e mês conta quantas usinas são de manutenção longo(L) e estão paradas no mês dado.*/
int count_halting_generating_units_maintenance_long(solutionhs **P, projectsh **project,int month, char area[]);

/*Restrições de máquina*/

/*Na localização RP*/
/*
Em um dado mês, se uma usina tem 2 ou mais unidades geradoras paradas, as outras
usinas não podem ter nenhuma unidade geradora parada.
*/
int RP_Location(solutionhs **P, projectsh **project);

/*Na localização BBB*/
/*
Em dado mês, se uma usina tem 2 ou mais unidades geradoras paradas, as outras
usinas não podem ter nenhuma unidade geradora parada.
*/
int BBB_Location1(solutionhs **P, projectsh **project);

/*
Em dado mês, no máximo duas unidades geradoras da usina BAR podem ser paradas.
*/
int BBB_Location2(solutionhs **P, projectsh **project);

/*
Em dado mês, 2 unidades geradoras de BAB pode ser paradas simultaneamente, mas
apenas se nenhum unidade geradora da usina BAR estiver parada.
*/
int BBB_Location3(solutionhs **P, projectsh **project);

/*Na Locailização NAPI*/
/*
No máximo duas unidadades geradoras podem ser paradas em um dado mês.
*/
int NAPI_Location(solutionhs **P, projectsh **project);

/*
Em um dado mês, se duas ou mais unidades geradoras de AGV estão paradas, então nenhuma unidade geradora das usinas BAB, NAV
ou PRO podem estar paradas.
*/
int Halting_restrictions_AGV_plant(solutionhs **P, projectsh **project);

/*
Em dado mês, não mais de 3 unidades geradoras da mesma divisão(COG, IT, AGV, PRO, BAR, LMO) podem ser paradas.
*/
int Halting_restrictions_division(solutionhs **P, projectsh **project);


int is_solution_valid(solutionhs **P,projectsh **mandatory_projects,projectsh **project,resources res);

#endif //CONSTRAINTS
