#include "json.h"

void read_json(projectsh **projetos,projectsh **mandatory_projetos, warning_pointshs **wp2, resources *res, char filename[]){

    Project entrada;
    warning_points entrada2;

    /*caminho para o diretorio do arquivo de entrada*/
    char path[1000];

    /*cria o caminho C:\User\..*/
    sprintf(path,PATH_INPUT);
    strcat(path,filename);

    FILE *f = NULL;
    long len = 0;
    char *data = NULL;
    cJSON *json = NULL;

    cJSON *limits = NULL;
    cJSON *limit = NULL;

    cJSON *values = NULL;
    cJSON *value = NULL;

    cJSON *projects = NULL;
    cJSON *project = NULL;

    cJSON *costs = NULL;
    cJSON *cost = NULL;

    cJSON *wps = NULL;
    cJSON *wp = NULL;

    cJSON *group_of_projects = NULL;
    cJSON *project_id = NULL;

    int i;
    int j;

    /* open in read binary mode */
    f = fopen(path,"rb");
    /* get the length */
    fseek(f, 0, SEEK_END);
    len = ftell(f);
    fseek(f, 0, SEEK_SET);

    data = (char*)malloc(len + 1);

    fread(data, 1, len, f);
    data[len] = '\0';
    fclose(f);

    json = cJSON_Parse(data);

    /*Ler recursos*/
    limits = cJSON_GetObjectItemCaseSensitive(json, "Limits");
    cJSON_ArrayForEach(limit, limits)
    {
        i = 1;
        j = 1;
        cJSON *classfication = cJSON_GetObjectItemCaseSensitive(limit, "Classification");

        values = cJSON_GetObjectItemCaseSensitive(limit, "Values");

        cJSON_ArrayForEach(value, values)
        {
            cJSON_GetObjectItemCaseSensitive(value, "Values");

            if(strcmp(classfication->valuestring,"CAPEX") == 0){
                res->capex[i] = value->valuedouble;
                i++;
            }else{
                res->opex[j] = value->valuedouble;
                j++;
            }


        }
        //printf("\n\n");
    }

    /*Ler projetos*/

    projects = cJSON_GetObjectItemCaseSensitive(json, "Projects");
    cJSON_ArrayForEach(project,projects)
    {

        cJSON *area = cJSON_GetObjectItemCaseSensitive(project, "Area");
        cJSON *classfication1 = cJSON_GetObjectItemCaseSensitive(project, "Classification");
        cJSON *duration1 = cJSON_GetObjectItemCaseSensitive(project, "Duration");
        cJSON *leadtime = cJSON_GetObjectItemCaseSensitive(project, "LeadTime");
        cJSON *obrigatory = cJSON_GetObjectItemCaseSensitive(project, "Obligatory");
        cJSON *maintance = cJSON_GetObjectItemCaseSensitive(project, "Maintenance");
        cJSON *GU = cJSON_GetObjectItemCaseSensitive(project, "Generating Unit");
        cJSON *HSM = cJSON_GetObjectItemCaseSensitive(project, "Halting Start Month");
        cJSON *HD = cJSON_GetObjectItemCaseSensitive(project, "Halting Duration");
        cJSON *id = cJSON_GetObjectItemCaseSensitive(project, "Id");
        cJSON *initialMonth = cJSON_GetObjectItemCaseSensitive(project, "InitialMonth");

        entrada.id = id->valueint;
        entrada.leadTime = leadtime->valueint;
        entrada.initialMonth = initialMonth->valueint;
        strcpy(entrada.area,area->valuestring);
        strcpy(entrada.classification,classfication1->valuestring);
        entrada.duration = duration1->valueint;
        strcpy(entrada.maintenance,maintance->valuestring);
        strcpy(entrada.obrigatory,obrigatory->valuestring);
        entrada.generating_unit = GU->valueint;
        entrada.halting_start_month = HSM->valueint;
        entrada.halting_duration = HD->valueint;


        costs = cJSON_GetObjectItemCaseSensitive(project, "Costs");
        i = 0;
        cJSON_ArrayForEach(cost, costs)
        {
            cJSON_GetObjectItemCaseSensitive(cost, "Costs");

            entrada.costs[i] = cost->valuedouble;

            i++;
        }

        if(strcmp(entrada.obrigatory,"Y") == 0){
            add_project(mandatory_projetos,entrada);
        }

        add_project(projetos,entrada);

    }

    /*ler pontos de atenção*/

    wps = cJSON_GetObjectItemCaseSensitive(json, "WarningPoints");
    cJSON_ArrayForEach(wp,wps)
    {
        cJSON *id = cJSON_GetObjectItemCaseSensitive(wp, "Id");
        cJSON *risk = cJSON_GetObjectItemCaseSensitive(wp, "Risk");
        cJSON *intolerable = cJSON_GetObjectItemCaseSensitive(wp, "Intolerable");
        cJSON *deadline = cJSON_GetObjectItemCaseSensitive(wp, "Deadline");

        entrada2.id = id->valueint;
        entrada2.risk = risk->valuedouble;
        strcpy(entrada2.risk_category,intolerable->valuestring);
        entrada2.deadline = deadline->valueint;

        group_of_projects = cJSON_GetObjectItemCaseSensitive(wp, "ProjectsId");

        int i = 0;

        cJSON_ArrayForEach(project_id, group_of_projects)
        {
            cJSON_GetObjectItemCaseSensitive(project_id, "ProjectsId");

            entrada2.group_of_projects[i] = project_id->valueint;

            i++;
        }
        entrada2.tam = i;
        add_warning_point(wp2,entrada2);

    }

    free(data);

}


void save_solution(projectsh **projects,warning_pointshs **wp,solutionhs **P,float rp_limitante, double executeTime, char *file){

    FILE *arq;
    char path[1000];
    solutionhs *s,*l;
    char localFileName[1000];

    strcpy(localFileName,file);

    cJSON *arrayOfSolution = NULL;
    cJSON *singleSolution = NULL;

     /*cria o caminho C:\User\..*/
    sprintf(path,PATH_OUTPUT);

    char *token;

    token = strtok(localFileName, ".");

    token = strtok(token,"-");
    token = strtok(NULL,"-");

    strcat(path, token);
    strcat(path, "-");

    token = strtok(NULL,"-");

    strcat(path, token);
    strcat(path, "-saida-");

    char timestamp[1000];
    sprintf(timestamp,"%ld",(unsigned long)time(NULL));

    strcat(path,timestamp);
    strcat(path,".json");

    arq = fopen(path,"w");
    if(arq == NULL){
        printf("\n\nErro na abertura do arquivo de salvamento de solucao!");
        exit(1);
    }

    /*Criando o JSON*/
    cJSON *json = cJSON_CreateObject();

    /*Adicionado o nome do arquivo de entrada*/
    cJSON_AddStringToObject(json, "File name", file);

    /*Adicionando a quantidade de projetos*/
    cJSON_AddNumberToObject(json,"Total projects", (HASH_COUNT(*projects)));

    /*Adicionando a quantidade de pontos de atenção*/
    cJSON_AddNumberToObject(json,"Total warning_points",HASH_COUNT(*wp));

    /*Adicionado o tempo de execução*/
    cJSON_AddNumberToObject(json,"Execution time", executeTime);

    //printf("Timestamp: %lu\n",(unsigned long)time(NULL));
    /*Adicionando o timestamp*/
    cJSON_AddNumberToObject(json,"Time Stamp", (unsigned long)time(NULL));

    /*Adicionado a solução*/
    arrayOfSolution = cJSON_AddArrayToObject(json,"Solution");

    HASH_ITER(hh,*P,s,l){

        singleSolution = cJSON_CreateObject();

        if(s->pid != -1){
            cJSON_AddNumberToObject(singleSolution, "Id", s->pid);
            cJSON_AddNumberToObject(singleSolution, "Month", s->m);

        }else{
            /*Adicionado o valor da função objetivo*/
            cJSON_AddNumberToObject(json,"Objetive function value",s->fitness);
            /*Adicionando a razão dos valores da função objetivo*/
            cJSON_AddNumberToObject(json,"Objetive function rate",s->fitness/rp_limitante);
        }

        cJSON_AddItemToArray(arrayOfSolution,singleSolution);

    }
    /*Adicionado valor da função objetivo do limitante*/
    cJSON_AddNumberToObject(json,"Objetive function limiting value",rp_limitante);

    char *string = cJSON_Print(json);

    //printf("\n\n\n%s",string);

    fprintf(arq,"%s",string);

    fclose(arq);


}


