#include <stdio.h>
#include <stdlib.h>
#include <time.h>

/* Custom library*/
#include "uthash.h"
#include "warning_point.h"
#include "projects.h"
#include "json.h"
#include "pwp.h"
#include "constraints.h"
#include "solution.h"
#include "brkga.h"

int main(int argc, char *argv[])
{

   /*printf("\n\nQuantidade de argumentos %d",argc);

    for(int i = 0; i < argc; i++){
        printf("\n\nArgv[%d]: %s",i,argv[i]);
    }
    printf("\n\n");*/


    solutionhs *P_limitante = NULL;
    solutionhs *P = NULL;
    projectsh *projects = NULL, *mandatory_projects = NULL;
    warning_pointshs *wp = NULL;
    pwphs *pwp = NULL;
    float fitness_limitante;
    clock_t start, end;
    double cpu_time_used;

    resources res;

    read_json(&projects,&mandatory_projects,&wp,&res,"entrada-100p-01.json");

    select_projects_to_warning_points(&wp,&pwp);
    category_risk_projects(&pwp,&wp);

    //print_projects(&projects);
    /*print_projects(&mandatory_projects);
    print_warning_points(&wp);
    print_projects_to_warning_points(&pwp);*/

    P_limitante = ideal_solution(&projects);
    fitness_limitante = fitness(&P_limitante,&projects,&wp);
    add_fitness_to_solution(&P_limitante,fitness_limitante);

    //printf("\n\nSolucao ideal");
    //print_solutions(&P_limitante);

    for(int i = 0; i < EXPERIMENT_NUM_TIMES; i++){
        start = clock();
        printf("\n\nIniciando %d",i+1);
        P = BRKGA_(&projects,&mandatory_projects,&pwp,&wp,&res);
        end = clock();

        cpu_time_used = ((double) (end - start) / CLOCKS_PER_SEC);
        //printf("\n\nMelhor solucao retornado do BRKGA");
        //print_solutions(&P);
        printf("\n\nSalvando %d",i+1);
        save_solution(&projects,&wp,&P,fitness_limitante, cpu_time_used,"entrada-100p-01.json");

    }


    /*printf("\n\nOrdenado\n\n");
    print_risk(&High_risk);
    printf("\n\n");
    print_risk(&Normal_risk);*/

    return 0;
}
