
#ifndef  PROJECTS_H
#define  PROJECTS_H

#include "stdio.h"
#include "uthash.h"

#define T 60

typedef struct {

	char area[10];/*Usina: COG,IT,BAR,LMO,etc*/
	char classification[5]; /*Capex ou Opex*/
	double costs[T];    /*Custo do projeto por ms*/
	int duration;   /*Durao do projeto*/
	int id; /*id do projeto*/
	int initialMonth;       /*Ms inicial do projeto*/
	char obrigatory[1];       /*Se  obrigatrio ou no: Y  obrigatrio e N no */
	int generating_unit;        /*Quantidade de usina geradaroas*/
	int halting_start_month;    /*Ms de parada*/
	int halting_duration;       /*Durao da parada*/
	char maintenance[1];        /*Se  de manuteno: N no manuteno L e S  de manuteno*/
	int leadTime;               /*Tempo de espera para o projeto ser iniciado.*/
	float Rp;
	float cost_total;           /*Custo total do projeto*/
	int tam;

}Project;

typedef struct {
	int pid;   /*  identificador de projeto */
    Project project;
	UT_hash_handle hh; /*  hash handle  */
}projectsh;

typedef struct{
    /*indexao comea com 1.*/
    float capex[6];
    float opex[6];
}resources;

projectsh *find_project(projectsh *projects,int pid); /*Encontra um projeto na hash de projetos*/

void add_project(projectsh **projects,Project entrada); /*Adiciona um projeto na hash de projetos*/

void delete_project(projectsh *projects,int pid); /*Deleta um projeto da hash de projeto*/

void print_projects(projectsh **projects); /*Imprime todos os projetos da hash de projetos*/

#endif
