
#ifndef PROJECT_TO_WARNINGPOINTS_H
#define PROJECT_TO_WARNINGPOINTS_H

#include <stdio.h>
#include "projects.h"
#include "warning_point.h"


typedef struct{

    int pos;                /*Posio que ser adiciona o projeto no vetor list_of_wp*/
    int risk;                /*Se o projeto  alto risco ou risco normal. 1:alto risco 0:risco normal*/
    int list_of_wp[100];      /*Lista de pontos de ateno que cada projeto pode ser resolvido.*/

}project_to_warningpoints;

typedef struct{

    int pid;
    project_to_warningpoints pwp;
    UT_hash_handle hh;

}pwphs;

pwphs *find_project_to_warning_points(pwphs *pwp, int proj);    /*Faz uma busca de um projeto na hash project_to_warning_points.*/

void create_warning_point_to_project(pwphs **pwp, int proj, int pid);   /*Cria e adiciona na hash projects_to_warning_points*/

void add_warning_point_to_project(pwphs *pwp, int proj, int pid );  /*Adiciona no vetor list_of_wp de um projeto j adcionado.*/

void select_projects_to_warning_points(warning_pointshs **wp, pwphs **pwp);

void print_projects_to_warning_points(pwphs **pwp); /*imprimi a lista de projects_to_warning_point*/

void category_risk_projects(pwphs **pwp, warning_pointshs **wp); /*Categoriza os projetos em alto risco ou risco normal*/

void calcule_R(projectsh **project, pwphs **pwp, warning_pointshs **wp);


#endif // PROJECT_TO_WARNINGPOINTS_H
