
#ifndef SOLUTION
#define SOLUTION

#include <time.h>
#include "projects.h"
#include "warning_point.h"

#define TRUE 1
#define FALSE 0

typedef struct{

	int pid; /*id da hash*/
	int m; /*mes*/
	float fitness;/*valor da funo fitness*/
	int subpopulation; /*0: Elite    1: No-elite   2:Mutante*/
	UT_hash_handle hh;

}solutionhs;


typedef struct{
    /*Estruturadas de dados que recebe a quantidade de usinas paradas em um certo ms*/

    int plants[6];

}usinas;

/*Estrutura auxiliar utilizada nas restries mquinas.Recebe as usinas.*/
typedef struct{

    char usina[4];  /*Usinas*/

}location;

extern float sum_all_wp_risk;

/*valores sero retiradas da entrada.*/

solutionhs *find_solution(solutionhs *P,int pid);    /*Faz a busca na hash soluo*/

void add_solution(solutionhs **P,int pid, int m);    /*Adiciona uma valor na hash de soluo*/

void print_solutions(solutionhs **P);   /*Lista todos os projetos da hash soluo*/

void delete_from_solution(solutionhs **P,int pid); /*Remove um elemento da hash de soluo*/

void schedule_mandatory_projects_in_solution(solutionhs **P,projectsh **project); /*Coloca os projetos obrigatrios na hash de soluo*/

/*Copia uma soluo para outra variavel. O primeiro parmetro  copiado para a o segundo parmetro*/
void copy_solution(solutionhs **P,solutionhs **Q);

void copy_solution_without_fitness(solutionhs **P,solutionhs **Q);

/*Soma todos os riscos assosciados aos projetos.*/
float calcule_all_wp_risk(warning_pointshs **wp);

/*Para uma dada soluo(parmetro) verifica se um dado ponto de ateno(parmetro)  controlado.*/
int is_wp_controlled(solutionhs **Q,warning_pointshs **wp,projectsh **projects,int wpid);

/*Calcula o valor de fw. fw  o ms mais tardio que um ponto de ateno  controlado.*/
int calcule_fw(solutionhs **Q,warning_pointshs **wp,projectsh **projects,int wpid);

/* o somatrio de todos os graus de riscos(ponto de ateno) controlado pela soluo.*/
int sum_wp_controlled_by_solution(solutionhs **Q,warning_pointshs **wp,projectsh **projects);

/*Faz o calculo do valor da funo objetiva*/
float fitness(solutionhs **Q,projectsh **projects,warning_pointshs **wp);

void add_fitness_to_solution(solutionhs **P,float rp);

void add_population_classification(solutionhs **P,int classification);

void insertion_sort(solutionhs *vetor[],int tam);

solutionhs *ideal_solution(projectsh **projects);

/*Verifica se cada projeto que controla um ponto de ateno intolervel na soluo  comletado antes da deadline.*/
int intolerable_points(warning_pointshs **wp,projectsh **project,solutionhs **P);

/*Procedimento que chama todas as restries.*/
int is_solution_valid(solutionhs **P,projectsh **mandatory_projects,projectsh **project,resources res);

void generate_solution(projectsh **projects, projectsh **mandatory_projects,warning_pointshs **wp ,solutionhs **P, resources res);

void schedule_projects_that_are_not_in_solution(projectsh **projects,solutionhs **P);

solutionhs *ideal_solution(projectsh **projects);
#endif //SOLUTION
