#ifndef WARNING_POINTS_H
#define WARNING_POINTS_H

#include <stdio.h>
#include "uthash.h"



#define TRUE 1
#define FALSE 0
typedef struct{

	int id;							/*Número identificador.*/
	float risk;			            /*Risco associado ao ponto de atenção.*/
	int group_of_projects[60];		/*Lista de projetos que o ponto de atenção controla.*/
	char risk_category[1];			/*Categoria do risco: T: Tolerável ou I: Intolerável.*/
	int deadline;					/*Ultimo mês que o ponto de atenção deve ser completamente controlado.*/
									/*O deadline é presente apenas em pontos de atenção de risco alto.*/
    float r;                        /*Porção de risco que o  ponto de atenção.*/
    int tam;

}warning_points;

typedef struct{

	int pid;
	warning_points warning_points;
	UT_hash_handle hh;

}warning_pointshs;

warning_pointshs *find_warning_point(warning_pointshs *wp,int pid);

void add_warning_point(warning_pointshs **wp, warning_points entrada);

void delete_warning_point(warning_pointshs *wp,int pid);

void print_warning_points(warning_pointshs **wp);

void read_input_wp(warning_pointshs **wp); /*Leitura do arquvio de entrada de pontos de atenção*/

#endif
