#include "grasp.h"


solutionhs *initial_solution(projectsh **projects){
    projectsh *s,*l;

    solutionhs *P=NULL;

    HASH_ITER(hh,*projects,s,l){

        add_solution(&P,s->pid,s->project.initialMonth);

    }

    return P;

}


solutionhs *grasp(projectsh **projects,projectsh **mandatory_projects,pwphs **pwp,warning_pointshs **wp,risk_hash **High_risk,risk_hash **Normal_risk,resources *res){


    risk_hash *High_risk2 = NULL,*Normal_risk2 = NULL;
    float best_rp,rp;
    solutionhs *s;
    solutionhs *pool_of_solutions[C];
    solutionhs *P=NULL,*best_solution;
    int countTimes = 0;
    int i,j;

    srand(time(NULL));

    i = 0;
    while(i < R){
        printf(" i:%d -",i);
        /*Inicialização do vetor de hash.*/
        for(int a = 0;a < C; a++){
            pool_of_solutions[a] = NULL;

        }
        best_solution = NULL;

        j = 0;
        while(j < C){
             printf("j:%d -",j);
            /*Faz a cópia das hash de risk para variáveis auxiliares.*/
            copy_risk_hash(High_risk,Normal_risk,&High_risk2,&Normal_risk2);

            /*Agenda os projetos obrigatórios na solução.*/
            schedule_mandatory_projects_in_solution(&pool_of_solutions[j],mandatory_projects);

            /*Fase de construção.*/
            solution_constrution(&High_risk2,&Normal_risk2,&pool_of_solutions[j],mandatory_projects,projects,*res);

            //print_solutions(&pool_of_solutions[j]);

            /*Se a solução construída passar pela restrição de pontos de atenção intoleráveis.*/
            if(intolerable_points(wp,projects,&pool_of_solutions[j])){
                /*Agendando os projetos que não fazem parte da solução para o mês 61*/
                schedule_projects_that_are_not_in_solution(projects,&pool_of_solutions[j]);

                /*Calculando o valor da função objetivo e gravando na hash da solução*/
                rp = objetive_function_value(&pool_of_solutions[j],projects,wp);
                add_rp_to_solution(&pool_of_solutions[j],rp);
                //printf("\n\nSolucao valida");

                //printf("\n\nSolucao: %d\n",j);
                //print_solutions(&pool_of_solutions[j]);
                j++;
            }
            /*Se a solução for inválida, ele recebe null.*/
            else{
                countTimes++;
                //printf("\n\nSolucao invalida");
                if(countTimes == 50){
                    printf("\n\nEntrada invalida");
                    exit(0);
                }
                pool_of_solutions[j] = NULL;
            }

        /*end while(j < 3)*/
        }
        printf("busca local");
        /*Fase de busca local*/

        /*Ordena o vetor de soluções em ordem crescente.*/
        //insertion_sort(pool_of_solutions,C);

        QUICKSORT(pool_of_solutions,0,C-1,C);

        /*printf("\n\nOrdenado");
        for(int i=0;i<C;i++){
            printf("\n\n");
            print_solutions(&pool_of_solutions[i]);
        }*/

        /*Inicializando best_rp com um valor inicial.*/

        /*Para cada solução no vetor faz um busca local.*/
        for(int l = 0;l < C; l++){

            printf("\nl:%d",l);
            P = local_search(&pool_of_solutions[l],mandatory_projects,projects,pwp,wp,*res);

            /*Inicializar a variavel best_solution com a primeira solução retornada da busca local.*/
            if(l == 0){
                copy_solution(&P,&best_solution);
            }

            /*É feito isso para pegar o valor rp da solução.*/
            s = find_solution(P,-1);

            if(s->rp < best_rp){

                best_rp = s->rp;
                best_solution = NULL;
                copy_solution(&P,&best_solution);

            }

            //printf("\n\nbest_rp:%.2f\n\n",best_rp);
            //system("pause");
        }
        i++;
        /*end while(i < R)*/
    }


    return best_solution;

}

solutionhs *GRASP_experiment_generator(projectsh **projects,projectsh **mandatory_projects,pwphs **pwp,warning_pointshs **wp,risk_hash **High_risk,risk_hash **Normal_risk,resources *res){


    int i;
    solutionhs *P = NULL;

    for(i = 0; i < EXPERIMENT_NUM_TIMES; i++){

        P = grasp(projects,mandatory_projects,pwp,wp,High_risk,Normal_risk,res);

    }



    return P;




}












