#include <stdio.h>
#include <stdlib.h>
#include <time.h>

/* Custom library*/
#include "uthash.h"
#include "warning_point.h"
#include "projects.h"
#include "pwp.h"
#include "json.h"
#include "beneftis.h"
#include "constraints.h"
#include "solution.h"
#include "grasp.h"




int main(int argc, char *argv[])
{

    solutionhs *P_limitante = NULL;
    solutionhs *P = NULL;
    warning_pointshs *wp = NULL;
    pwphs *pwp = NULL;
    projectsh *projects = NULL;
    projectsh *mandatory_projects = NULL;
    risk_hash *High_risk = NULL;
    float rp_limitante;
    risk_hash *Normal_risk = NULL;
    clock_t start, end;
    double cpu_time_used;
    resources res;

    read_json(&projects,&mandatory_projects,&wp,&res,"entrada-50p-01.json");

    select_projects_to_warning_points(&wp,&pwp);
    category_risk_projects(&pwp,&wp);

    /*print_projects(&projects);
    print_projects(&mandatory_projects);
    print_warning_points(&wp);
    print_projects_to_warning_points(&pwp);*/

    P_limitante = ideal_solution(&projects);
    rp_limitante = objetive_function_value(&P_limitante,&projects,&wp);
    add_rp_to_solution(&P_limitante,rp_limitante);

    calcule_R(&projects,&pwp,&wp);

    calcule_benefit(&High_risk,&Normal_risk,&projects,&pwp);

    sorting(&High_risk);
    sorting(&Normal_risk);

    /*printf("\n\nOrdenado\n\n");
    print_risk(&High_risk);
    printf("\n\n");
    print_risk(&Normal_risk);*/


    for(int i=0;i<EXPERIMENT_NUM_TIMES;i++){
       start = clock();
       printf("\nExecucao: %d",i);
       P = grasp(&projects,&mandatory_projects,&pwp,&wp,&High_risk,&Normal_risk,&res);
       end = clock();
       cpu_time_used = ((double) (end - start) / CLOCKS_PER_SEC);
        //printf("\n\nMelhor solucao retornado do grasp:\n");
        //print_solutions(&P);
        printf("\nSalvando");
        save_solution(&projects,&wp,&P,rp_limitante, cpu_time_used,"entrada-50p-01.json");
   }

   printf("\n\nACABOU");



   return 0;
}
