#include "projects.h"

 projectsh *find_project(projectsh *projects,int pid) {

    projectsh *s;

    HASH_FIND_INT(projects, &pid, s);

    return s;

}

void add_project(projectsh **projects, Project entrada){

    projectsh *s;

	s = (projectsh*)malloc( sizeof(projectsh) );
    memset(s, 0, sizeof(projectsh));

	s->pid = entrada.id;    /*id do projeto*/
	s->project.initialMonth = entrada.initialMonth; /*ms de inicio do projeto*/
	s->project.leadTime = entrada.leadTime;
	strcpy(s->project.obrigatory,entrada.obrigatory);   /*se o projeto  obrigatrio*/
	s->project.maintenance[0] = entrada.maintenance[0];    /*tipo da manuteno: L, S, N*/
	strcpy(s->project.area,entrada.area);   /*Usina do projeto*/
	s->project.generating_unit = entrada.generating_unit;   /*unidade geradoras*/
	s->project.halting_start_month = entrada.halting_start_month;  /*ms de parada*/
	s->project.halting_duration = entrada.halting_duration; /*durano da parada*/
	strcpy(s->project.classification,entrada.classification);   /*tipo do recurso : CAPEX ou OPEX*/
	s->project.duration = entrada.duration;

	s->project.cost_total = 0;
	for(int i = 0; i < s->project.duration; i++){             /*custo do projeto por mes*/
        s->project.costs[i] = entrada.costs[i];
        s->project.cost_total += entrada.costs[i];              /*Somando o custo total;*/
	}


	HASH_ADD_INT(*projects, pid, s);

}

void delete_project(projectsh *projects,int pid) {
    projectsh *s;
    HASH_FIND_INT(projects, &pid, s);
    HASH_DEL(projects, s);
    free(s);
}

void print_projects(projectsh **projects){
    projectsh *s;

    for(s = *projects; s != NULL; s =(projectsh*) (s->hh.next)){
        printf("\n\n");
        printf("\nId: %d",s->pid);
        printf("\nMes inicial: %d",s->project.initialMonth);
        printf("\nLead Time: %d",s->project.leadTime);
        printf("\nObrigatorio: %s",s->project.obrigatory);
        printf("\nManuntencao: %c",s->project.maintenance[0]);
        printf("\nUsina: %s",s->project.area);
        printf("\nUnidade geradora: %d",s->project.generating_unit);
        printf("\nMes de parada: %d",s->project.halting_start_month);
        printf("\nDuracao da parada: %d",s->project.halting_duration);
        printf("\nTipo do recurso: %s",s->project.classification);
        printf("\nDuracao: %d",s->project.duration);
        printf("\nCustos: ");

        for(int i = 0; i < s->project.duration; i++){
            printf("%.4f ",s->project.costs[i]);

        }
        printf("\nCusto total: %.4f",s->project.cost_total);
    }

}

void select_mandatory_projects(projectsh **projects, projectsh **mandatory_projects){

    projectsh *s,*l;

    HASH_ITER(hh,*projects,s,l){

        /*Se o projeto for obrigatrio*/
        if(strcmp(s->project.obrigatory,"Y") == 0){
            add_project(mandatory_projects,s->project);
        }

    }


}





