#include "pwp.h"

pwphs *find_project_to_warning_points(pwphs *pwp, int proj){/*Faz uma busca na hash de project_to_warning_points por um projeto.*/

    pwphs *s;

    HASH_FIND_INT(pwp, &proj, s);

    return s;
}

void create_warning_point_to_project(pwphs **pwp, int proj, int pid){  /*Cria um elemento na hash project_to_warning_points*/
                                                                        /*e adiciona na primeira posio de list_of_wp o warning point.*/
    pwphs *s;
   // printf("\n\npid:%d proj:%d",pid,proj);
    s = (pwphs*)malloc( sizeof(pwphs) );
    memset(s, 0, sizeof(pwphs));

    s->pwp.pos=0;
	s->pid = proj;
    s->pwp.list_of_wp[0] = pid;

	HASH_ADD_INT(*pwp, pid, s);

}
void add_warning_point_to_project(pwphs *pwp, int proj, int pid ){      /*Adiciona no list_of_wp um novo elemento*/

    pwphs *s;

    s = find_project_to_warning_points(pwp,proj);

    s->pwp.pos++;
    s->pwp.list_of_wp[s->pwp.pos] = pid;


}

void select_projects_to_warning_points(warning_pointshs **wp, pwphs **pwp){

    warning_pointshs *s,*l;

    HASH_ITER(hh, *wp, s, l){

        for(int i = 0; i < s->warning_points.tam ; i++){

            //printf("\n %d ",s->warning_points.group_of_projects[i]);
            if(find_project_to_warning_points(*pwp, s->warning_points.group_of_projects[i])){

                /* Adiciona um ponto de atencao a um projeto existe  */
                 add_warning_point_to_project(*pwp, s->warning_points.group_of_projects[i], s->pid );

            }else{

                /* Criar um novo projeto na hash de project_to_warning_points*/
                create_warning_point_to_project(pwp, s->warning_points.group_of_projects[i],s->pid);

            }
        }

    }
}

void print_projects_to_warning_points(pwphs **pwp){

    pwphs *s,*l;

    HASH_ITER(hh,*pwp,s,l){

        printf("\nId: %d",s->pid);
        printf("\nRisco: %d",s->pwp.risk);
        printf("\nLista de wp: ");
        for(int i = 0; i <= s->pwp.pos; i++){
            printf("%d ",s->pwp.list_of_wp[i]);

        }
        printf("\n\n");
    }

}

void category_risk_projects(pwphs **pwp, warning_pointshs **wp){


    pwphs *s,*l;
    warning_pointshs *q;

    HASH_ITER(hh, *pwp, s,l){

        for(int i=0; i<=s->pwp.pos; i++){

            q = find_warning_point(*wp,s->pwp.list_of_wp[i]);

            /*Se o projeto controlar algum ponto de ateno intolervel, esse projeto  de alto risco*/
            if( strcmp(q->warning_points.risk_category,"I") == 0){
                s->pwp.risk = 1;
            }
        }
    }

}

void calcule_R(projectsh **project, pwphs **pwp, warning_pointshs **wp){

    projectsh *s,*l;
    pwphs *q;
    warning_pointshs *t;

    HASH_ITER(hh, *project, s, l){

        /*restos dos projetos que no foram agendados, ou seja, no obrigatrios.*/
        if(strcmp(s->project.obrigatory,"N") == 0){

            /*encontra o projeto de pid igual na hash de projects_to_warning_points*/
            if( (q = find_project_to_warning_points(*pwp,s->pid)) ){
                //printf("\n\nprojeto = %d",s->pid);
                /*percorre toda a lista de pontos de ateno que o projeto controla*/
                for(int i = 0; i<=q->pwp.pos; i++){
                    //printf("\n\nwp = %d",q->pwp.list_of_wp[i]);
                    /*encontra o ponto de ateno com o mesmo pid*/
                    t = find_warning_point(*wp,q->pwp.list_of_wp[i]);

                    /*adiciona seu valor r ao vetor de Rsum*/
                    s->project.Rp += t->warning_points.r;


                }
                s->project.tam = q->pwp.pos;
            }
        }
    }

}





