#include "solution.h"


solutionhs *find_solution(solutionhs *P,int pid) {

    solutionhs *s;

    HASH_FIND_INT(P, &pid, s);

    return s;

}

void add_solution(solutionhs **P,int pid, int m){

    solutionhs *s;

	//s = (solutionhs*)malloc( sizeof(solutionhs) );
    //memset(&s, 0, sizeof(solutionhs));

    s = calloc(1, sizeof(solutionhs));

    s->pid = pid;
    s->m = m;

    HASH_ADD_INT(*P, pid, s);

}
void add_rp_to_solution(solutionhs **P,float rp){

    solutionhs *s;

	/*s = (solutionhs*)malloc( sizeof(solutionhs) );
    memset(&s, 0, sizeof(solutionhs));*/

    s = calloc(1, sizeof(solutionhs));

    s->pid = -1;
    s->m = -1;
    s->rp = rp;

    HASH_ADD_INT(*P, pid, s);

}


void print_solutions(solutionhs **P){

    solutionhs *s;

    for(s = *P; s != NULL; s =(solutionhs*) (s->hh.next)){
        if(s->pid == -1){
            printf("\nP id %d : m = %d : rp = %.2f",s->pid,s->m,s->rp);
        }else{
            printf("\nP id %d : m = %d",s->pid,s->m);
        }

    }
}

void delete_from_solution(solutionhs **P,int pid) {
    solutionhs *r;
    HASH_FIND_INT(*P, &pid, r);
    HASH_DEL(*P, r);
    free(r);
}



void schedule_mandatory_projects_in_solution(solutionhs **P,projectsh **mandatory_projects){

    projectsh *s,*l;

    HASH_ITER(hh, *mandatory_projects, s, l){

        add_solution(P,s->pid,s->project.initialMonth);

    }
}


void solution_constrution(risk_hash **High_risk, risk_hash **Normal_risk,solutionhs **P,projectsh **mandatory_projects,projectsh **project,resources res){

    risk_hash *s;
    risk_hash *chosen_hash;
    int controle = -1;
    int first_k;
    int i;
    int eta;

    /*Enquanto as hashs no forem vazias*/
    while((*High_risk != NULL) || (*Normal_risk != NULL)){

        /*Escolha umas das hashs de risco*/
        if(*High_risk == NULL){

            //printf("\nNormal Risk");
            chosen_hash = *Normal_risk;
            controle = 0;

        }else{
            if(*Normal_risk == NULL ){
                //printf("\nHigh Risk");
                chosen_hash = *High_risk;
                controle = 1;

            }else{
                /*Escolhe aleatriamente umas das hash de risco.*/
                eta = rand()%10;
                //printf("\n\nEta: %d",eta);

                /*a probabilidade de escolher a lista de alto risco  de 70%.*/
                if((eta >= 0) &&(eta <= ETA)){

                    //printf("\nHigh Risk");
                    chosen_hash = *High_risk;
                    controle = 1;

                }else{

                    //printf("\nNormal Risk");
                    chosen_hash = *Normal_risk;
                    controle = 0;
                }

            }
        }


        int hcount = HASH_COUNT(chosen_hash);

        first_k = rand()%k;

        first_k = first_k < hcount ? first_k : hcount;

        /*Quando sair do loop, first_k = i*/
        i = 0;
        s=chosen_hash;
        while(i < first_k-1){
            s=s->hh.next;
            i++;
        }
        risk_key pair;

        pair.pid = s->benefit.pid;
        pair.m = s->benefit.m;


        //printf("\nEscolhido pid: %d m: %d\n",pair.pid,pair.m);
        //system("pause");

        /*Verifica se o projeto, j no est na soluo*/
        if(find_solution(*P,pair.pid) == NULL){

            /*adiciona na hash de soluo para fazer o teste de restries.*/
            add_solution(P,pair.pid,pair.m);

            /*Caso no respeite as restries retiro da soluo*/
            //printf("\n\nAdicionado pid:%d m: %d",pair.pid,pair.m);
            if(!(is_solution_valid(P,mandatory_projects,project,res))){
                //printf("\n\nAntes de deletar pid:%d m:%d",pair.pid,pair.m);
                /*deleta da soluo caso no atenda as restries*/
                delete_from_solution(P,pair.pid);
            }

        }
        if(controle == 0){
            *Normal_risk = delete_risk(&chosen_hash,pair);
        }else{
            *High_risk = delete_risk(&chosen_hash,pair);
        }
    }

}




void copy_solution(solutionhs **origin,solutionhs **target){

    solutionhs *s,*l;

    HASH_ITER(hh,*origin,s,l){

        if(s->pid != -1){
            add_solution(target,s->pid,s->m);
        }else{
            add_rp_to_solution(target,s->rp);
        }
    }
}

solutionhs *generate_neighbor(solutionhs **P,solutionhs **neighbor, projectsh **mandatory_projects,projectsh **projects,warning_pointshs **wp,resources res,int pid, int m ,int i){

    if((m - DELTA + i <= 0)){
        return NULL;
    }else{

        if((m + DELTA + i >= T)){
            return NULL;

        }else{

            //printf("\n\npid:%d m:%d i:%d",pid,m,i);
            delete_from_solution(neighbor,pid);
            add_solution(neighbor,pid,m-DELTA+i);
            if(!(is_solution_valid(neighbor,mandatory_projects,projects,res)) || ((!intolerable_points(wp,projects,P))) ){
                //printf("\n\npid:%d m:%d",pid,m-DELTA+i);
                return NULL;
            }

        }
    }
    return *neighbor;
}
float calcule_all_wp_risk(warning_pointshs **wp){

    warning_pointshs *s,*l;
    float rp = 0;

    HASH_ITER(hh,*wp,s,l){

        rp = rp + s->warning_points.risk;

    }

    return rp;
}


int is_wp_controlled(solutionhs **neighbor,warning_pointshs **wp,projectsh **projects,int wpid){


    warning_pointshs *s;
    solutionhs *q;
    projectsh *t;

    /*Encontrar o ponto de ateno correspondente na hash de pontos de ateno*/
    s = find_warning_point(*wp,wpid);

    /*Percorrer o vetor de projetos desse ponto de ateno*/
    for(int i = 0; i< s->warning_points.tam;i++){

        /*Encontrar o projeto na soluo para saber seu mes de agendamento*/
        if(!(q = find_solution(*neighbor,s->warning_points.group_of_projects[i]))){
            printf("\n\nNao encontrado na solucao");
            return FALSE;
        }
        /*Encontrar o projeto na hash de soluo para saber seu temmpo de durao*/
        if(!(t = find_project(*projects,s->warning_points.group_of_projects[i]))){
            printf("\n\nProjeto nao encontrado");
            return FALSE;
        }

        /*Se o mes agendado mais a durao for maior que T, retorna falso*/
        //printf("\n\nwpid: %d pid: %d q->m:%d t->project.duration:%d",wpid,s->warning_points.group_of_projects[i],q->m,t->project.duration);
        if(q->m + t->project.duration -1> T){
            //printf("\n\n%d + %d Ultrapassou T.",q->m,t->project.duration);
            return FALSE;
        }
    }

    return TRUE;

}


int calcule_fw(solutionhs **neighbor,warning_pointshs **wp,projectsh **projects,int wpid){

    warning_pointshs *s;
    solutionhs *q;
    projectsh *t;
    int max = 0;

    /*Encontrar o ponto de ateno correspondente na hash de pontos de ateno*/
    s = find_warning_point(*wp,wpid);

    /*Percorrer o vetor de projetos desse ponto de ateno*/
    for(int i = 0; i< s->warning_points.tam;i++){

        /*Encontrar o projeto na soluo para saber seu mes de agendamento*/
        q = find_solution(*neighbor,s->warning_points.group_of_projects[i]);
        /*Encontrar o projeto na hash de soluo para saber seu temmpo de durao*/
        t = find_project(*projects,s->warning_points.group_of_projects[i]);

        /*Se o mes agendado mais a durao for maior que max, max recebe esse valor*/
        if(q->m + t->project.duration - 1  > max){
            max = q->m + t->project.duration -1;
        }
    }

    //printf("\n\nmax:%d",max);
    return max;
}
int sum_wp_controlled_by_solution(solutionhs **neighbor,warning_pointshs **wp,projectsh **projects){

    warning_pointshs *s,*l;
    float controlled_risk = 0;
    float aux;

    /*Percorre toda a hash de pontos de ateno*/
    HASH_ITER(hh,*wp,s,l){

        /*Verifica se o ponto de ateno  controlado.*/
        if(is_wp_controlled(neighbor,wp,projects,s->pid)){
            /*Se for controlado pela soluo o grau de risco  somado*/

        //printf("\nid:%d",s->pid);
         aux = 2*T - calcule_fw(neighbor,wp,projects,s->pid);

         controlled_risk += s->warning_points.risk * aux;


     }
 }
    //printf("\n\ncontrolled_risk:%.2f",controlled_risk);
 return controlled_risk;

}


float objetive_function_value(solutionhs **neighbor,projectsh **projects,warning_pointshs **wp){


    return 2 * T * calcule_all_wp_risk(wp) - sum_wp_controlled_by_solution(neighbor,wp,projects);

}



solutionhs *local_search(solutionhs **P,projectsh **mandatory_projects,projectsh **projects,pwphs **pwp,warning_pointshs **wp,resources res){


    solutionhs *s,*l;
    solutionhs *neighbor;//*solution = NULL;
    solutionhs *currentSolution = NULL;
    solutionhs *currentSolution2 = NULL;
    solutionhs *best_solution = NULL;
    projectsh *q;
    int i;
    float rp,best_rp;

    copy_solution(P, &currentSolution);
    copy_solution(P, &currentSolution2);
    copy_solution(P, &best_solution);
    /*Inicializa a variavel best_rp com o valor do rp da primeira soluo inicial.*/
    best_rp = objetive_function_value(&currentSolution,projects,wp);
    //printf("\n\nrp solucao inicial: %.2f",best_rp);
    //print_solutions(&currentSolution);

    /*Executa a busca local b vezes.*/
    for(int t = 0; t < b; t++){

        printf("\n t:%d best_rp:%.2f",t,best_rp);

        /*Percorre cada projeto na hash de soluo.*/
        HASH_ITER(hh,currentSolution2,s,l){

            /*Verifica se o pid  -1 (armazena o rp da soluo) ou o ms de agendamento  maior que 60(no faz parte da soluo).*/
            if((s->pid != -1) && (s->m < 60)){

                /*Procura o projeto correspondente na hash de projetos para ter acesso aos seus atributos.*/
                q = find_project(*projects,s->pid);

                /*Se no for obrigatrio*/
                if((strcmp(q->project.obrigatory,"N") == 0)){

                    /*Para cada projeto  feito o seu reagendamento do ms.*/
                    for(i = 0; i < 2*DELTA; i++){

                        neighbor = NULL;
                        //printf("\n\nSolucao P %d\n\n",i);
                        //print_solutions(P);
                        //copy_solution(&currentSolution, &neighbor);
                        neighbor = currentSolution;

                       // printf("\n\n");
                        //print_solutions(&currentSolution);

                        /*m - DELTA*/
                        if(i < DELTA){
                            neighbor = generate_neighbor(&currentSolution, &neighbor,mandatory_projects,projects,wp,res,s->pid,s->m,i);
                        /*m + DELTA*/
                        }else{
                            neighbor = generate_neighbor(&currentSolution, &neighbor,mandatory_projects,projects,wp,res,s->pid,s->m,i+1);
                        }

                        /*Se neighbor possuir uma soluo vizinha.*/
                        if(neighbor){


                            /*Faz o calculo do rp da soluo vizinha encontrada.*/
                            rp = objetive_function_value(&neighbor,projects,wp);
                            /*Deleta o valor rp antigo que estava armazenado na soluo com id -1.*/
                            delete_from_solution(&neighbor,-1);
                            /*Adicionado o novo valor do rp na soluo com id -1*/
                            add_rp_to_solution(&neighbor,rp);

                            //printf("\n\nS_risk: %.2f",rp);

                            //print_solutions(&neighbor);
                            //printf("\n\n");

                            /*Caso encontre um valor de rp menor,  alterado o valor na varivel best_rp e best_soluo.*/
                            if(rp < best_rp){

                                //printf("\nbest_rp:%.2f",best_rp);
                                //printf("\nS_risk: %.2f",rp);

                                best_rp = rp;

                                best_solution = NULL;

                                copy_solution(&neighbor,&best_solution);
                                //print_solutions(&best_solution  );

                            /*Se o rp da soluo vizinha encontrada no for menor, ento ela  descartada.*/
                            }
                            //print_solutions(P);
                        }
                    }
                }
            }
        }

        //printf("\n2 t:%d best_rp:%.2f",t,best_rp);

       // printf("\n\nbestsolution");
       // print_solutions(&best_solution);

        currentSolution=NULL;
        currentSolution2=NULL;

        copy_solution(&best_solution, &currentSolution);
        copy_solution(&best_solution, &currentSolution2);

        //printf("\n\nSolucao P");
        //print_solutions(&currentSolution2);

    }
    /*Retorna a melhor soluo encontrada baseado no rp dela.*/
    //print_solutions(&the_best_solution);

    return best_solution;
}



void swap_solution(solutionhs **A,solutionhs **B){

    solutionhs *aux;

    aux = *A;
    *A = *B;
    *B = aux;

}




solutionhs *ideal_solution(projectsh **projects){

    solutionhs *P = NULL;
    projectsh *s,*l;


    HASH_ITER(hh,*projects,s,l){

        /*Se o projeto no for obrigatrio*/
        if(strcmp(s->project.obrigatory,"N")==0){
            add_solution(&P,s->pid,1);
        }else{
            add_solution(&P,s->pid,s->project.initialMonth);
        }
    }

    return P;
}

void schedule_projects_that_are_not_in_solution(projectsh **projects,solutionhs **P){

    projectsh *s,*l;
    solutionhs *q;

    HASH_ITER(hh,*projects,s,l){

        q = find_solution(*P,s->pid);

        /*Se o projeto no est na soluo.*/
        if(!(q)){
            add_solution(P,s->pid,61);
        }
    }
}

void insertion_sort(solutionhs *vetor[],int tam){              /*Ordenao por insero*/

int i, j;
solutionhs *atual = NULL;
solutionhs *s,*q;

for (i = 1; i < tam; i++)
{
    atual = vetor[i];
    j = i - 1;

    s = find_solution(atual,-1);
    q = find_solution(vetor[j],-1);

        //printf("\ns->rp: %.2f",s->rp);
        //printf("\nq->rp: %.2f",q->rp);

    while ((j >= 0) && (s->rp < q->rp)){

        swap_solution(&vetor[j+1],&vetor[j]);
        j = j - 1;

        if(j != -1){
            q = find_solution(vetor[j],-1);
        }

    }

    vetor[j + 1] = atual;
}

}


void QUICKSORT(solutionhs *vetor[],int ini,int fim,int tam){		/*QuickSort*/


	int i,j;
	solutionhs *key;
	solutionhs *s,*q;

	s = find_solution(vetor[ini],-1);  //inicio
	q = find_solution(vetor[fim],-1);  //fim


	if(fim - ini < 2){
		if(fim - ini == 1){
			if(s->rp > q->rp){
				swap_solution(&vetor[fim],&vetor[ini]);
			}
		}

	}
	else{

		i=ini;
		j=fim-1;

		key = find_solution(vetor[fim],-1);


		while(j >= i){

            s = find_solution(vetor[i],-1);
			while(s->rp < key->rp){
				i++;
				s = find_solution(vetor[i],-1);
			}

            q = find_solution(vetor[j],-1);
			while(q->rp > key->rp){
				j--;
				if(j < 0){
                    break;
				}
                q = find_solution(vetor[j],-1);


			}
			if(j >= i){

                swap_solution(&vetor[j], &vetor[i]);
				i++;
				j--;
			}
		}
		swap_solution(&vetor[fim],&vetor[i]);

		QUICKSORT(vetor,ini,i-1,tam);
		QUICKSORT(vetor,i+1,fim,tam);
	}

}






