
#ifndef SOLUTION
#define SOLUTION

#include <time.h>
#include "projects.h"
#include "beneftis.h"


#define DELTA 8
#define TRUE 1
#define FALSE 0
#define ETA 6
#define k 5
#define b 5 /*numero de vezes que a busca local vai ser executada*/

typedef struct{

	int pid; /*id da hash*/
	int m; /*mes*/
	float rp;
	UT_hash_handle hh;

}solutionhs;


typedef struct{
    /*Estruturadas de dados que recebe a quantidade de usinas paradas em um certo ms*/

    int plants[6];

}usinas;

/*Estrutura auxiliar utilizada nas restries mquinas.Recebe as usinas.*/
typedef struct{

    char usina[4];  /*Usinas*/

}location;

extern float sum_all_wp_risk;

/*valores sero retiradas da entrada.*/

solutionhs *find_solution(solutionhs *P,int pid);    /*Faz a busca na hash soluo*/

void add_solution(solutionhs **P,int pid, int m);    /*Adiciona uma valor na hash de soluo*/

void print_solutions(solutionhs **P);   /*Lista todos os projetos da hash soluo*/

void delete_from_solution(solutionhs **P,int pid); /*Remove um elemento da hash de soluo*/

void schedule_mandatory_projects_in_solution(solutionhs **P,projectsh **project); /*Coloca os projetos obrigatrios na hash de soluo*/

/*Controi uma soluo.*/
void solution_constrution(risk_hash **High_risk, risk_hash **Normal_risk,solutionhs **P,projectsh **mandatory_projects,projectsh **project,resources res);

/*Copia uma soluo para outra variavel. O primeiro parmetro  copiado para a o segundo parmetro*/
void copy_solution(solutionhs **P,solutionhs **neighbor);

/*Gera uma soluo vizinha a partir de uma soluo inicial.*/
solutionhs *generate_neighbor(solutionhs **P,solutionhs **neighbor, projectsh **mandatory_projects,projectsh **projects,warning_pointshs **wp,resources res,int pid, int m ,int i);

/*Soma todos os riscos assosciados aos projetos.*/
float calcule_all_wp_risk(warning_pointshs **wp);

/*Para uma dada soluo(parmetro) verifica se um dado ponto de ateno(parmetro)  controlado.*/
int is_wp_controlled(solutionhs **neighbor,warning_pointshs **wp,projectsh **projects,int wpid);

/*Calcula o valor de fw. fw  o ms mais tardio que um ponto de ateno  controlado.*/
int calcule_fw(solutionhs **neighbor,warning_pointshs **wp,projectsh **projects,int wpid);

/* o somatrio de todos os graus de riscos(ponto de ateno) controlado pela soluo.*/
int sum_wp_controlled_by_solution(solutionhs **neighbor,warning_pointshs **wp,projectsh **projects);

/*Faz o calculo do valor da funo objetiva*/
float objetive_function_value(solutionhs **neighbor,projectsh **projects,warning_pointshs **wp);

/*Escolhe a melhor soluo.*/
solutionhs *local_search(solutionhs **P,projectsh **mandatory_projects,projectsh **projects,pwphs **pwp,warning_pointshs **wp,resources res);

void add_rp_to_solution(solutionhs **P,float rp);

void insertion_sort(solutionhs *vetor[],int tam);

void QUICKSORT(solutionhs *vetor[],int ini,int fim,int tam);

solutionhs *ideal_solution(projectsh **projects);

/*Verifica se cada projeto que controla um ponto de ateno intolervel na soluo  comletado antes da deadline.*/
int intolerable_points(warning_pointshs **wp,projectsh **project,solutionhs **P);


/*Agenda os projetos que no fazem parte da soluo para o ms 61.*/
void schedule_projects_that_are_not_in_solution(projectsh **projects,solutionhs **P);

int is_solution_valid(solutionhs **P,projectsh **mandatory_projects,projectsh **project,resources res);
#endif //SOLUTION
