#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <windows.h>

#define path_input "C:\\Users\\bruno\\Desktop\\TCC\\Dados\\Entradas"

#define path_brkga "C:\\Users\\bruno\\Desktop\\TCC\\BRKGA\\bin\\Debug\\BRKGA.exe"

#define path_grasp "C:\\Users\\bruno\\Desktop\\TCC\\GRASP\\bin\\Debug\\GRASP.exe"

#define runTimes 1

/*determina qual algoritmo ser executado
    BRKGA = 1   GRASP = 2
*/
int chosen;

void Run_Experiment(char filename[]){



	char path[1000]; /*caminho para o diretorio de entradas*/

	/*
	Escolha de qual algoritmo ser executado
	BRKGA = 1  GRASP = 2
	*/
	if(chosen == 1){
        /*passa para a variavel path o caminho do executavel do BRKGA*/
        sprintf(path, path_brkga);
	}else{
        /*passa para a variavel path o caminho do executavel do GRASP*/
        sprintf(path, path_grasp);
	}

    /*concatenando com um espao necessrio entre o executavel e o argumento (arquivo de entrada) que ser passado*/
    strcat(path," ");

    /*concatenando com o arquivo de entrada que ser passado*/
	strcat(path,filename);

	printf("\n\npath:%s\n\n",path);

   // Gives info on the thread and process for the new process
	PROCESS_INFORMATION pif;

   // Defines how to start the program
	STARTUPINFO si;

   // Zero the STARTUPINFO struct
	ZeroMemory( &si, sizeof( si ) );

   // Must set size of structure
	si.cb = sizeof( si );

	ZeroMemory( &pif, sizeof(pif) );

   BOOL bRet = CreateProcess( NULL, // Path to executable file
                              path,   // Command string - not needed here
                              NULL,   // Process handle not inherited
                              NULL,   // Thread handle not inherited
                              FALSE,  // No inheritance of handles
                              0,      // No special flags
                              NULL,   // Same environment block as this prog
                              NULL,   // Current directory - no separate path
                              &si,    // Pointer to STARTUPINFO
                              &pif ); // Pointer to PROCESS_INFORMATION

   if( FALSE == bRet )
   {
   	MessageBox( HWND_DESKTOP, "Unable to start program", "", MB_OK );
   	exit(0);
   }
   WaitForSingleObject(pif.hProcess,INFINITE);
   // Close handle to process
   CloseHandle( pif.hProcess );

   // Close handle to thread
   CloseHandle( pif.hThread );
 }


 void Generate_Experiments(){

	 struct dirent *de;  // Pointer for directory entry

    // opendir() returns a pointer of DIR type.
	 DIR *dr = opendir(path_input);

    if (dr == NULL)  // opendir returns NULL if couldn't open directory
    {
    	printf("Could not open current directory" );
    	exit(0);
    }

    // Refer http://pubs.opengroup.org/onlinepubs/7990989775/xsh/readdir.html
    // for readdir()
    while ((de = readdir(dr)) != NULL){
        //printf("%s\n", de->d_name);
    	if( (strcmp(de->d_name,".") != 0) && (strcmp(de->d_name,"..") != 0)){

    		for(int i=0; i < runTimes; i++){
                Run_Experiment(de->d_name);
    		}
    	}
    }
    closedir(dr);

  }



  int main()
  {

    printf("\n\nExecutando GRASP");
    chosen = 2;
    Generate_Experiments();

    printf("\n\nExecutando BRKGA");
    chosen = 1;
    Generate_Experiments();



    return 0;
 }
