#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include "cJSON.h"


#define OUTPUT_PATH "C:\\Users\\bruno\\Desktop\\TCC\\Dados\\Entradas\\"

#define resources 1000000


/*Essa estrutura é utilizada para gerar random de strings.*/
typedef struct{

    char s[100];

}random_of_strings;

void GeradorJson(int mult,int num_proj,int j)
{

    FILE *F;
    char filename[100];
    char path[1000];


    /*Variáveis auxiliares para armazenar valores de recurso*/
    int min_capex = 999999999;
    int min_opex = 999999999;
    int recurso;

    /*Variáveis auxiliares para armazenar valores de projeto*/
    int id_proj = 1;
    int initalMonth;
    char obrigatory[5];
    char area[5];
    char maintence[5];
    int halting_duration;
    int duration;
    char resource[10];
    int id_proj_nao_obrigatorio[num_proj];    /*Vetor que conterá apenas o Id dos projetos não obrigatório.*/
    int index_vetor = 0;    /*Indíce do id_proj_nao_obrigatorio.*/

    /*Variáveis auxiliares para armazenar valores de pontos de atenção.*/

    int id_ponto_de_atencao = 1;
    char intolerable[5];
    int vetor_id_que_ja_foram_colocados[num_proj];   /*Vetor que servirá para saber qual projeto já foi adicionado ao grupo de projeto do ponto de atenção.*/

    /*Random dos tipos de recursos dos projetos.
        0: CAPEX    1: OPEX
    */
    random_of_strings projeto_resource[2];
    strcpy(projeto_resource[0].s,"CAPEX");
    strcpy(projeto_resource[1].s,"OPEX");

    /*Random dos tipos de obrigação dos projetos.
        0: Y    1: N
    */
    random_of_strings projeto_obrigatory[2];
    strcpy(projeto_obrigatory[0].s,"Y");
    strcpy(projeto_obrigatory[1].s,"N");

    /*Random dos tipos de manunteção dos projetos.
        0: S    1: L   2: N
    */
    random_of_strings projeto_maintence[3];
    strcpy(projeto_maintence[0].s,"S");
    strcpy(projeto_maintence[1].s,"L");
    strcpy(projeto_maintence[2].s,"N");

    /*Random das áreas do projetos.
        0: AGV  1: BAB  2: BAR
        3: CAC  4: EUC  5: IBI
        6: LMO  7: MOG  8: NAV
        9: PRO  10: SJS 11: SJQ
    */
    random_of_strings projeto_area[12];
    strcpy(projeto_area[0].s,"AGV");
    strcpy(projeto_area[1].s,"BAB");
    strcpy(projeto_area[2].s,"BAR");
    strcpy(projeto_area[3].s,"CAC");
    strcpy(projeto_area[4].s,"EUC");
    strcpy(projeto_area[5].s,"IBI");
    strcpy(projeto_area[6].s,"LMO");
    strcpy(projeto_area[7].s,"MOG");
    strcpy(projeto_area[8].s,"NAV");
    strcpy(projeto_area[9].s,"PRO");
    strcpy(projeto_area[10].s,"SJS");
    strcpy(projeto_area[11].s,"SJQ");

    /*Random do tipo de ponto de atenção
        0: I    1: T
    */
    random_of_strings pontos_de_atencao_intoleraveis[2];
    strcpy(pontos_de_atencao_intoleraveis[0].s,"I");
    strcpy(pontos_de_atencao_intoleraveis[1].s,"T");

    cJSON *projetos = NULL;
    cJSON *projeto = NULL;

    cJSON *custos = NULL;
    cJSON *custo = NULL;

    cJSON *limites = NULL;
    cJSON *limite = NULL;

    cJSON *valores = NULL;
    cJSON *valor = NULL;

    cJSON *pontos_de_atencao = NULL;
    cJSON *ponto_de_atencao = NULL;

    cJSON *projetos_id = NULL;
    cJSON *projeto_id = NULL;

    /*Cria o json.*/
    cJSON *json = cJSON_CreateObject();
/*--------------------------------------Gerando os recursos----------------------------------------------------*/


    /*Cria um objeto com nome de Limits.*/
    limites = cJSON_AddArrayToObject(json, "Limits");

    /*Gerando os recursos.*/
    for(int index = 0; index < 2; index++){

        limite = cJSON_CreateObject();

        /*Se o index é 0, então está gerando os valores de CAPEX.*/
        if(index == 0){
            cJSON_AddStringToObject(limite, "Classification", "CAPEX");
        /*Se o index é 1, então está gerando os valores de OPEX.*/
        }else{
            cJSON_AddStringToObject(limite, "Classification", "OPEX");
        }

        valores = cJSON_AddArrayToObject(limite,"Values");

        /*Gerando os valores*/

        for (int index1 = 0; index1 < 5; index1++)
        {
            recurso = mult * ((((rand()%100) * resources)/100) + resources);

            /*Encontra o menor valor dos recursos de CAPEX*/
            if((index == 0) && (min_capex > recurso)){
                min_capex = recurso;
            }

            /*Encontra o menor valor dos recursos de OPEX*/
            if((index == 1) && (min_opex > recurso)){
                min_opex = recurso;
            }
            valor = cJSON_CreateNumber(recurso);

            cJSON_AddItemToArray(valores, valor);
        }

        cJSON_AddItemToArray(limites, limite);
    }


/*--------------------------------------Gerando os projetos----------------------------------------------------*/

    /*Criando uma lista no json*/
    projetos = cJSON_CreateArray();

    /*Cria um objeto com nome Projects.*/
    cJSON_AddItemToObject(json, "Projects", projetos);

    /*Adiciona a informação de cada projeto.*/
    for (int index = 0; index < num_proj; index++){
        projeto = cJSON_CreateObject();

        cJSON_AddNumberToObject(projeto, "Id", id_proj ); /*Id do projeto*/

        /*Random do mês que o projeto irá iniciar de 1 a 60.*/
        initalMonth = rand()%60+1;
        cJSON_AddNumberToObject(projeto, "InitialMonth", initalMonth); /*Mês inicial*/

         /*Random da duração do projeto é 5 a 15 meses.*/
        duration = ((rand()%11) +5);
        cJSON_AddNumberToObject(projeto, "Duration",duration);

        /*Random da área do projeto.*/
        strcpy(area,projeto_area[rand()%12].s);
        cJSON_AddStringToObject(projeto, "Area", area);

        /*Random da quantidade de unidade geradoras por área.
        O rand vai depender da quantidade máxima de unidades por área.
        */

        /*Rand de 6*/
        if(strcmp(area,"AGV") == 0){
            cJSON_AddNumberToObject(projeto, "Generating Unit", (rand()%6 +1));
        }
        /*Rand de 4*/
        if((strcmp(area,"BAB") == 0)|| (strcmp(area,"EUC") == 0)){
            cJSON_AddNumberToObject(projeto, "Generating Unit", (rand()%4 +1));
        }
        /*Rand de 3*/
        if((strcmp(area,"NAV") == 0) || (strcmp(area,"PRO") == 0 || (strcmp(area,"BAR") == 0) || (strcmp(area,"IBI") == 0))){
            cJSON_AddNumberToObject(projeto, "Generating Unit", (rand()%3 +1));
        }
        /*Rand de 2*/
        if((strcmp(area,"CAC") == 0) || (strcmp(area,"LMO") == 0 || (strcmp(area,"MOG") == 0) || (strcmp(area,"SJS") == 0))){
            cJSON_AddNumberToObject(projeto, "Generating Unit", (rand()%2 +1));
        }
        /*Só possui uma unidade geradora*/
        if(strcmp(area,"SJQ")== 0){
            cJSON_AddNumberToObject(projeto, "Generating Unit", 1);
        }

        /*Random dos recursos. 0: CAPEX 1: OPEX*/
        strcpy(resource,projeto_resource[rand()%2].s);
        cJSON_AddStringToObject(projeto, "Classification", resource);

        /*Random das obrigação. 0: Y(Obrigatório) 1: N(Não Obrigatório)*/
        int x = rand()%10;

        /*20% dos projetos são obrigatórios e 80% são não obrigatórios.*/
        /*Se for obrigatório*/
        if(x < 2){
            strcpy(obrigatory,projeto_obrigatory[0].s);
            cJSON_AddStringToObject(projeto, "Obligatory", obrigatory);
        }else{
            strcpy(obrigatory,projeto_obrigatory[1].s);
            cJSON_AddStringToObject(projeto, "Obligatory", obrigatory);
            /*Se o projeto é não obrigatório, então ele é adicionado no vetor de projetos não obrigatórios.*/
            //printf("\nindex_vetor:%d  id_proj: %d",index_vetor,id_proj);
            id_proj_nao_obrigatorio[index_vetor] = id_proj;
            index_vetor++;
        }

        /*Se o projeto for obrigatório, então ele é de não manutenção*/
        if(strcmp(obrigatory,"Y") == 0){
            strcpy(maintence,projeto_maintence[2].s);
            cJSON_AddStringToObject(projeto, "Maintenance", maintence);
        }else{

            /*Random dos tipos de manutenção. 0: S(Curto) 1:L(Longo) 2:N(Não é de manutenção)*/
            /*80% não são de manutenção e 20% são de manutenção curto ou longo.*/

            x = rand()%10;
            /*Se for de  manutenção*/
            if(x < 8){
                strcpy(maintence,projeto_maintence[2].s);
                cJSON_AddStringToObject(projeto, "Maintenance", maintence);
            /*Se não for de manunteção, 50% de chance de ser curto ou longo.*/
            }else{

                /*Projeto de manutenção curto são projetos resolvidos em até 2 meses.*/
                if(duration < 7){
                    strcpy(maintence,projeto_maintence[0].s);
                    cJSON_AddStringToObject(projeto, "Maintenance", maintence);
                /*Projeto de manutenção longo são projetos resolvidos em mais de 2 meses.*/
                }else{
                    strcpy(maintence,projeto_maintence[1].s);
                    cJSON_AddStringToObject(projeto, "Maintenance", maintence);
                }
            }
        }

        /*Se o projeto é obrigatório, então seu leadTime é 0.*/
        if(strcmp(obrigatory,"Y") == 0){
            /*leadtime 0*/
            cJSON_AddNumberToObject(projeto, "LeadTime", 0);
        }else{
            /*Random do leadtime é de 0 a 12 meses.*/
            cJSON_AddNumberToObject(projeto, "LeadTime",rand()%13);


        }


        /*Random do mês inicial de parada e duração da parada.
        Projetos de não manutenção não possuem essas informações, portanto é defino como -1.
        */
        if((strcmp(maintence,"N") == 0)){
            cJSON_AddNumberToObject(projeto, "Halting Start Month", -1);
            cJSON_AddNumberToObject(projeto, "Halting Duration", -1);
        }else{

            halting_duration = ((rand()%duration)+1);
            if((duration - halting_duration) == 0){
                cJSON_AddNumberToObject(projeto, "Halting Start Month",1);
                cJSON_AddNumberToObject(projeto, "Halting Duration", halting_duration);
            }else{
                cJSON_AddNumberToObject(projeto, "Halting Start Month",rand()%(duration - halting_duration) + 1);
                cJSON_AddNumberToObject(projeto, "Halting Duration", halting_duration);
            }
        }

        /*Os custos do projetos são de 1% a 2% do menor recurso do tipo do recurso.*/
        custos = cJSON_AddArrayToObject(projeto,"Costs");
        for (int index1 = 0; index1 < duration; index1++){

            /*Se o recurso é CAPEX, então utiliza o min_capex para gerar os custos*/
            if(strcmp(resource,"CAPEX") == 0){

                custo = cJSON_CreateNumber( (((((rand()%2) + 1) * min_capex)/100 )/10));


            }else{
            /*Se o recurso é OPEX, então utiliza o min_opex para gerar os custos*/
                custo = cJSON_CreateNumber( ((((rand()%2) + 1) * min_opex)/100 )/10);
            }

            //printf("\n\nCusto: %.2f",custo->valuedouble);
            cJSON_AddItemToArray(custos, custo);
        }


        cJSON_AddItemToArray(projetos, projeto);
        id_proj++;
    }

 /*--------------------------------------Gerando os pontos de atenção----------------------------------------------------*/

    /*Copiando o vetor auxiliar.*/
    for(int index = 0; index < index_vetor; index++){

        vetor_id_que_ja_foram_colocados[index] = id_proj_nao_obrigatorio[index];
    }

    /*Criando uma lista*/
    pontos_de_atencao = cJSON_CreateArray();
    /*Criando o objeto com nome WarningPoints.*/
    cJSON_AddItemToObject(json, "WarningPoints", pontos_de_atencao);

   /*A quantidade pontos de atenção é 30% da quantidade de projetos.*/
   for(int index = 0; index < (0.3 * num_proj); index++){

        ponto_de_atencao = cJSON_CreateObject();
        ponto_de_atencao = cJSON_CreateObject();

        /*Gerando o Id do ponto de atenção.*/
        cJSON_AddNumberToObject(ponto_de_atencao, "Id", id_ponto_de_atencao);

        /*Random do grau de risco é de 1 a 100.*/
        cJSON_AddNumberToObject(ponto_de_atencao, "Risk", (rand()%100 +1));

        /*5% dos pontos de atenção são intoleráveis e 95% toleráveis*/
        /*  0: I(Intolerável)   1: T(Tolerável)*/
        int x = rand()%100;
        if(x < 5){
            strcpy(intolerable,pontos_de_atencao_intoleraveis[0].s);
            cJSON_AddStringToObject(ponto_de_atencao,"Intolerable", intolerable);
        }
        else{
            strcpy(intolerable,pontos_de_atencao_intoleraveis[1].s);
            cJSON_AddStringToObject(ponto_de_atencao,"Intolerable", intolerable);
        }
        id_proj_nao_obrigatorio[0] = vetor_id_que_ja_foram_colocados[0];

        /*Apenas pontos de atenção intoleráveis possuem deadline.
        Random do deadline é de 40 a 60.
        */
        /*Se for intolerável*/
        if(strcmp(intolerable,"I") == 0){
            cJSON_AddNumberToObject(ponto_de_atencao, "Deadline", (rand()%21) + 40);
        /*Se for tolerável*/
        }else{
            cJSON_AddNumberToObject(ponto_de_atencao, "Deadline", -1);
        }

        projetos_id = cJSON_AddArrayToObject(ponto_de_atencao,"ProjectsId");

        /*Variável auxliar do while.*/
        int index1 = 0;

        /*Cada ponto de atenção será controlado por 1% a 5% da quantidade de projetos.*/
        int l = 0.05 * num_proj;
        int lim_gro_proj = (((rand()%5)+1) * num_proj)/100;

        while(index1 < l ){

            /*Escolhe um índice aleatório do vetor de id de projetos de não obrigatório.*/
            int p = rand()%index_vetor;
            //printf("\nindex:%d index1: %d p:%d index2_vetor:%d\n",index,index1,p,index2_vetor);

            /*Para determinar se o Id já foi adiconado na lista de projetos, é utilizado um vetor cópia auxiliar.
            Toda vez que um índice for escolhido é verificado se no vetor auxiliar está -1, ou seja, já foi adicionado.
            Caso seja -1 (já foi adicionado),então não acontece nada. Caso não for -1 (ainda não foi adicionado), então a posição desse
            índice no vetor auxiliar recebe -1, o índice do vetor é adicionado no arquivo json e o index1 é incrementado.
            */
            if(vetor_id_que_ja_foram_colocados[p] != -1){

                vetor_id_que_ja_foram_colocados[p] = -1;
                projeto_id = cJSON_CreateNumber(id_proj_nao_obrigatorio[p]);
                cJSON_AddItemToArray(projetos_id, projeto_id);
            }
            index1++;
            if(index1 >= lim_gro_proj){
                break;
            }
        }

        cJSON_AddItemToArray(pontos_de_atencao, ponto_de_atencao);
        /*Incremento o Id de pontos de atenção.*/
        id_ponto_de_atencao++;

        /*Resetando os valores do vetor cópia auxiliar.*/
        for(int index2 = 0; index2 < index_vetor; index2++){
            vetor_id_que_ja_foram_colocados[index2] = id_proj_nao_obrigatorio[index2];
        }
   }

    /*String recebe o formato json gerado.*/
    char *string = cJSON_Print(json);
    //printf("%s\n\n",string);

   /* for(int i=0;i<index_vetor;i++){
        printf("%d ",id_proj_nao_obrigatorio[i]);
    }

    printf("\n\nMin Capex: %d\nMin Opex:%d",min_capex,min_opex);*/
    strcpy(path,OUTPUT_PATH);
    sprintf(filename,"entrada-%dp-%02d.json",num_proj,j+1);
    strcat(path,filename);
    printf("\n\n%s",path);

    /*Gravando no arquivo txt o json gerado.*/
    F = fopen(path,"w");
    if(F == NULL){
        printf("\n\nErro ao abrir o arquivo.");
        exit(1);
    }

    //printf("%s",string);
    fprintf(F,"%s",string);

    fclose(F);

}
int main()
{
    /*Numeros de projeto*/


    srand(time(NULL));


    int iLenght = 5;
    int jLenght = 10;

    int vetor_entrada[] = {30, 50, 100, 150, 200};

    for(int i = 0; i < iLenght ; i++){
        for(int j = 0; j < jLenght; j++){
            printf("\ni:%d vetor[%d]:%d",i,i,vetor_entrada[i]);
            GeradorJson((i+1),vetor_entrada[i],j);
        }
    }


    return 0;
}
